# SPDX-FileCopyrightText: 2022 CERN (home.cern)
#
# SPDX-License-Identifier: LGPL-2.1-or-later

hdl_simulation:
  interruptible: true
  stage: build
  when: manual
  needs: [sim_fw_build]
  tags:
    - questasim
    - "10.5c"
  parallel:
    matrix:
      - SIM_NAME:
          - wrtd_ref_spec150t_adc
          - wrtd_ref_svec_tdc_fd
  before_script:
    - export TMP_DIR=$(mktemp -d)
    - git submodule init && git submodule update
  script:
    - cd hdl/testbench/"$SIM_NAME"/
    - cp /opt/compiled_libs_ise14.7/modelsim.ini .
    - hdlmake
    - make
    - vsim -c -do run.do
    - |
      if [[ $(cat transcript | tail -1 | grep -c "Errors: 0") = 0 ]]
      then
        echo -e "\e[31mSimulation errors detected. Aborting...\e[0m"
        exit 1
      fi
  artifacts:
    name: "$SIM_NAME-$CI_JOB_NAME-$CI_COMMIT_REF_NAME"
    paths:
      - hdl/testbench/$SIM_NAME/transcript
